SystemOrganization addCategory: #'Estanciero-Tests'!

TestCase subclass: #EstancieroTest
	instanceVariableNames: 'formosaZonaSur zonaSur formosaZonaCentro zonaCentro formosaZonaNorte zonaNorte petrolera formosa salta saltaZonaSur saltaZonaCentro saltaZonaNorte bodega tucuman tucumanZonaSur tucumanZonaNorte fabrica cordoba cordobaZonaSur cordobaZonaCentro cordobaZonaNorte jacobo samuel david'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Estanciero-Tests'!

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:35'!
setUp 

Tablero instance initialize.
Juego instance initialize.
Tablero instance agregarCasillero: Salida instance.

formosa := Provincia new.

formosaZonaSur := Campo new.
formosa agregarCampo: formosaZonaSur.
formosaZonaSur precioDeCompra: 1000.
formosaZonaSur valorDeRentaFijo: 500.
formosaZonaSur costoDeEstancia: 500.
Tablero instance agregarCasillero: formosaZonaSur.

formosaZonaCentro := Campo new.
formosa agregarCampo: formosaZonaCentro.
formosaZonaCentro precioDeCompra: 1000.
formosaZonaCentro valorDeRentaFijo: 500.
formosaZonaCentro costoDeEstancia: 250.
Tablero instance agregarCasillero: formosaZonaCentro.

formosaZonaNorte := Campo new.
formosa agregarCampo: formosaZonaNorte.
formosaZonaNorte precioDeCompra: 1200.
formosaZonaNorte valorDeRentaFijo: 600.
formosaZonaNorte costoDeEstancia: 300.
Tablero instance agregarCasillero: formosaZonaNorte.

Tablero instance agregarCasillero: PremioGanadero instance.

petrolera := Empresa new.
petrolera precioDeCompra: 380.
Tablero instance agregarCasillero: petrolera.

salta := Provincia new.

saltaZonaSur := Campo new.
salta agregarCampo: saltaZonaSur.
saltaZonaSur precioDeCompra: 2600.
saltaZonaSur valorDeRentaFijo: 800.
saltaZonaSur costoDeEstancia: 300.
Tablero instance agregarCasillero: saltaZonaSur.

saltaZonaCentro := Campo new.
salta agregarCampo: saltaZonaCentro.
saltaZonaCentro precioDeCompra: 2600.
saltaZonaCentro  valorDeRentaFijo: 850.
saltaZonaCentro  costoDeEstancia: 300.
Tablero instance agregarCasillero: saltaZonaCentro.

saltaZonaNorte := Campo new.
salta agregarCampo: saltaZonaNorte.
saltaZonaNorte precioDeCompra: 3000.
saltaZonaNorte valorDeRentaFijo: 900.
saltaZonaNorte costoDeEstancia: 350.
Tablero instance agregarCasillero: saltaZonaNorte.

bodega := Empresa new.
bodega precioDeCompra: 380.
Tablero instance agregarCasillero: bodega.

Tablero instance agregarCasillero: Comisaria instance.

tucuman := Provincia new.

tucumanZonaSur := Campo new.
tucuman agregarCampo: tucumanZonaSur.
tucumanZonaSur precioDeCompra: 5000.
tucumanZonaSur valorDeRentaFijo: 1000.
tucumanZonaSur costoDeEstancia: 400.
Tablero instance agregarCasillero: tucumanZonaSur.

tucumanZonaNorte := Campo new.
tucuman agregarCampo: tucumanZonaNorte.
tucumanZonaNorte precioDeCompra: 5400.
tucumanZonaNorte valorDeRentaFijo: 1200.
tucumanZonaNorte costoDeEstancia: 500.
Tablero instance agregarCasillero: tucumanZonaNorte.

fabrica := Empresa new.
fabrica precioDeCompra: 380.
Tablero instance agregarCasillero: fabrica.

cordoba := Provincia new.

cordobaZonaSur := Campo new.
cordoba agregarCampo: cordobaZonaSur.
cordobaZonaSur precioDeCompra: 6000.
cordobaZonaSur valorDeRentaFijo: 1500.
cordobaZonaSur costoDeEstancia: 800.
Tablero instance agregarCasillero: cordobaZonaSur.

cordobaZonaCentro := Campo new.
cordoba agregarCampo: cordobaZonaCentro.
cordobaZonaCentro precioDeCompra: 6000.
cordobaZonaCentro valorDeRentaFijo: 1500.
cordobaZonaCentro costoDeEstancia: 800.
Tablero instance agregarCasillero: cordobaZonaCentro.

cordobaZonaNorte := Campo new.
cordoba agregarCampo: cordobaZonaNorte.
cordobaZonaNorte precioDeCompra: 6400.
cordobaZonaNorte valorDeRentaFijo: 1500.
cordobaZonaNorte costoDeEstancia: 900.
Tablero instance agregarCasillero: cordobaZonaNorte.

jacobo := Jugador new.
jacobo cobra: 50000.
jacobo agregarPropiedad: tucumanZonaSur.
tucumanZonaSur duenio: jacobo.
jacobo agregarPropiedad: tucumanZonaNorte.
tucumanZonaNorte duenio: jacobo.
jacobo agregarPropiedad: formosaZonaSur.
formosaZonaSur duenio: jacobo.
tucumanZonaNorte sumarEstancia.
Juego instance agregarJugador: jacobo.

samuel := Jugador new.
samuel cobra: 10000.
samuel agregarPropiedad: cordobaZonaSur. 
cordobaZonaSur duenio: samuel.
samuel agregarPropiedad: cordobaZonaCentro. 
cordobaZonaCentro duenio: samuel.
samuel agregarPropiedad: cordobaZonaNorte.
cordobaZonaNorte duenio: samuel.
samuel agregarPropiedad: formosaZonaCentro.
formosaZonaCentro duenio: samuel.
samuel agregarPropiedad: bodega.
bodega duenio: samuel.
samuel agregarPropiedad: petrolera.
petrolera duenio: samuel.
Juego instance agregarJugador: samuel.

david := Jugador new.
Juego instance agregarJugador: david.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:47'!
testCantidadDeEmpresasDeSamuel

self assert: samuel cantidadDeEmpresas equals: 2.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:28'!
testDueniosDeFormosa

|coleccionJugadores|

coleccionJugadores := Set new.
coleccionJugadores add: samuel.
coleccionJugadores add: jacobo.
coleccionJugadores add: Banco instance.
self assert: (formosa duenios) equals: coleccionJugadores.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:27'!
testDueniosDeTucuman

|coleccionJugadores|

coleccionJugadores := Set new.
coleccionJugadores add: jacobo.
self assert: (tucuman duenios) equals: coleccionJugadores.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:13'!
testJacoboCompraLaFabricaYConsultaRentaParaSamuel

|intervalo|

intervalo := Interval from: 60000 to: 360000.

jacobo compra: fabrica.

self assert: (intervalo includes: (fabrica rentaPara: samuel) )equals:  true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:37'!
testJacoboConstruyeEstanciaEnTucumanZonaSur

jacobo construirEstanciaEn: tucumanZonaSur.
self assert: jacobo dinero equals: 49600.
self assert: tucumanZonaSur cantidadDeEstancias  equals: 1.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:20'!
testJacoboGarcaCaeEnFormosaZonaNorteYLaCompra

jacobo usarEstrategia: EstrategiaGarca new.
formosaZonaNorte cayo: jacobo.

self assert:((jacobo propiedades) includes: formosaZonaNorte) equals: true.
self assert: jacobo dinero equals: 48800.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:04'!
testJacoboHipotecaTucumanZonaNorte

jacobo hipoteca: tucumanZonaNorte.

self assert: tucumanZonaNorte duenio equals: Banco instance.
self assert: jacobo dinero equals: 52950.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:46'!
testJacoboImperialistaCaeEnCordobaZonaSurYNoLaCompra

jacobo usarEstrategia: EstrategiaImperialista new.
cordobaZonaSur cayo: jacobo .

self assert:((jacobo propiedades) includes: cordobaZonaSur) equals: false.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:44'!
testJacoboIntentaConstruirEstanciaEnFormosaZonaCentro

jacobo construirEstanciaEn: formosaZonaCentro.
formosaZonaCentro cantidadDeEstancias.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:46'!
testJacoboIntentaConstruirEstanciaEnTucumanZonaNorte

jacobo construirEstanciaEn: tucumanZonaNorte.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:16'!
testJacoboPaga10000ASamuel

jacobo pagaA: samuel elMontoDe: 10000.

self assert: samuel dinero  equals: 20000.
self assert: jacobo dinero  equals: 40000.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:37'!
testJacoboPasaPorFormosaZonaCentro

formosaZonaCentro paso: jacobo.

self assert: samuel dinero = 10000 equals: true.
self assert: jacobo dinero = 50000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:10'!
testJacoboTiraLosDadosYSacaEntre2Y12

|intervalo|

intervalo := Interval from: 2 to: 12.
jacobo tirarDados.

self assert: (intervalo includes: (jacobo valor)) equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:53'!
testRentaDeTucumanZonaNorteParaSamuel

self assert: (tucumanZonaNorte rentaPara: samuel ) equals: 2400.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 02:52'!
testRentaDeTucumanZonaSurParaSamuel

self assert: (tucumanZonaSur rentaPara: samuel ) equals: 1000.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:15'!
testRestaDeBodegaParaJacobo

|intervalo|

intervalo := Interval from: 120000 to: 720000.

self assert: (intervalo includes: (bodega rentaPara: jacobo) )equals:  true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:08'!
testSamuelCaeEnFormosaZonaCentro

formosaZonaCentro cayo: samuel.

self assert: samuel dinero = 10000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:41'!
testSamuelCaeEnLaSalida

Salida instance cayo: samuel.

self assert: samuel dinero = 10000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:52'!
testSamuelCaeEnPremioGanadero

PremioGanadero instance cayo: samuel.

self assert: samuel dinero = 12500 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:11'!
testSamuelCaeEnSaltaZonaSurYLaCompra

saltaZonaSur cayo: samuel.

self assert: ((samuel propiedades) includes: saltaZonaSur)  equals: true.
self assert: samuel dinero = 7400 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 04:13'!
testSamuelCaeEnTucumanZonaSurYLePagaAJacobo

tucumanZonaSur cayo: samuel.

self assert: jacobo dinero = 51000 equals: true.
self assert: samuel dinero = 9000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:58'!
testSamuelCaePorPrision

| propiedades |
Prision instance cayo: samuel.

propiedades := Set new.
propiedades add: cordobaZonaSur .
propiedades add: cordobaZonaCentro.
propiedades add: cordobaZonaNorte.
propiedades add: formosaZonaCentro.
propiedades add: bodega.
propiedades add: petrolera.

self assert: samuel dinero equals: 10000.
self assert: samuel propiedades  equals: propiedades.
self assert: samuel estado class equals: JugadorLibre.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:22'!
testSamuelGarcaCaeEnSaltaZonaSurYNoLaCompra

samuel usarEstrategia: EstrategiaGarca new.
saltaZonaSur cayo: samuel .

self assert:((samuel propiedades) includes: saltaZonaSur) equals: false.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:03'!
testSamuelHipotecaCordobaZonaNorte

samuel hipoteca: cordobaZonaNorte.

self assert: cordobaZonaNorte duenio equals: Banco instance.
self assert: samuel dinero equals: 13200.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:05'!
testSamuelHipotecabodega

samuel hipoteca: bodega.

self assert: bodega duenio equals: Banco instance.
self assert: samuel dinero equals: 10190.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:39'!
testSamuelImperialistaCaeEnFormosaZonaNorteYLaCompra

samuel usarEstrategia: EstrategiaImperialista new.
formosaZonaNorte cayo: samuel .

self assert:((samuel propiedades) includes: formosaZonaNorte) equals: true.
self assert: samuel dinero equals: 8800.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 01:44'!
testSamuelImperialistaCaeEnSaltaZonaSurYLaCompra

samuel usarEstrategia: EstrategiaImperialista new.
saltaZonaSur cayo: samuel .

self assert:((samuel propiedades) includes: saltaZonaSur) equals: true.
self assert: samuel dinero equals: 7400.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:36'!
testSamuelJuegaYCambiaDeLugar

samuel casilleroDondeEsta: (PremioGanadero instance).
Juego instance queJuegue: samuel.

self  assert: (samuel casilleroDondeEsta) = (PremioGanadero instance) equals: false.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 02:14'!
testSamuelLePagaAJacobo50000YCaeEnBancarrota

samuel pagaA: jacobo elMontoDe: 50000.

self assert: jacobo dinero equals: 50000.
! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:34'!
testSamuelPaga12000AJacobo

samuel pagaA: jacobo elMontoDe: 12000.

self assert: samuel dinero = 10000 equals: false.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:40'!
testSamuelPasaPorElPremioGanadero

PremioGanadero instance paso: samuel.

self assert: samuel dinero = 10000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/15/2012 03:36'!
testSamuelPasaPorLaSalida

Salida instance paso: samuel.

self assert: samuel dinero = 15000 equals: true.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:58'!
testSamuelPasaPorPrision

| propiedades |
Prision instance paso: samuel.

propiedades := Set new.
propiedades add: cordobaZonaSur .
propiedades add: cordobaZonaCentro.
propiedades add: cordobaZonaNorte.
propiedades add: formosaZonaCentro.
propiedades add: bodega.
propiedades add: petrolera.

self assert: samuel dinero equals: 10000.
self assert: samuel propiedades  equals: propiedades.
self assert: samuel estado class equals: JugadorLibre.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 03:08'!
testSamuelQuedaEnBancarrotaYSigueDavid

Juego instance queJuegueElQueSigue.
samuel perdiste.
Juego instance queJuegueElQueSigue.

self assert: (david casilleroDondeEsta =  Salida instance) equals: false.! !

!EstancieroTest methodsFor: 'as yet unclassified' stamp: 'Nahuel 10/16/2012 00:13'!
testSamuelSeMueveYPasaPorLaSalida

| recorrido |

recorrido := (Tablero instance) casillerosDesde: cordobaZonaNorte  hasta: 2.
samuel movetePor: recorrido.

self assert: samuel dinero equals: 14500.
self assert: samuel casilleroDondeEsta equals: formosaZonaSur.
! !
